"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.baseQueryWithReAuth = exports.baseQuery = void 0;
const query_1 = require("@reduxjs/toolkit/query");
const async_mutex_1 = require("async-mutex");
const mutex = new async_mutex_1.Mutex();
const baseQuery = (args) => (0, query_1.fetchBaseQuery)(args);
exports.baseQuery = baseQuery;
const baseQueryWithReAuth = (baseQueryArgs, when401) => (args, api, extraOptions) => __awaiter(void 0, void 0, void 0, function* () {
    var _a;
    yield mutex.waitForUnlock();
    let result = yield (0, exports.baseQuery)(baseQueryArgs)(args, api, extraOptions);
    if (((_a = result.error) === null || _a === void 0 ? void 0 : _a.status) === 401) {
        if (!mutex.isLocked()) {
            const release = yield mutex.acquire();
            try {
                yield when401(api);
            }
            finally {
                release();
            }
        }
        else {
            yield mutex.waitForUnlock();
            result = yield (0, exports.baseQuery)(baseQueryArgs)(args, api, extraOptions);
        }
    }
    return result;
});
exports.baseQueryWithReAuth = baseQueryWithReAuth;
